'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                                StarGate                                  |
'//|                              Version 1.02                                |
'//|                                                                          |
'//|   How to ceate a mini demoscene using Bass.dll and OpenGL altogether.    |
'//|                                                                          |
'//|          The GDImage.dll unregistered version has no limitation,         |
'//|             and all features of the API are fully functional.            |
'//|                                                                          |
'//|       Buying a commercial license removes the copyright nag screen.      |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                         Author Patrice TERRIER                           |
'//|                           copyright (c) 2010                             |
'//|                                                                          |
'//|                        pterrier@zapsolution.com                          |
'//|                                                                          |
'//|                          www.zapsolution.com                             |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                  Project started on : 09-19-2010 (MM-DD-YYYY)            |
'//|                        Last revised : 09-26-2010 (MM-DD-YYYY)            |
'//+--------------------------------------------------------------------------+

#COMPILE EXE "StarGate.exe"

%WINAPI                                         = 1
%FW_BOLD                                        = 700
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%ERROR_ALREADY_EXISTS                           = 183
%ANSI_VAR_FONT                                  = 12
%SW_RESTORE                                     = 9
%VK_PGUP                                        = &H21
%VK_PGDN                                        = &H22
%VK_LEFT                                        = &H25
%VK_UP                                          = &H26
%VK_RIGHT                                       = &H27
%VK_DOWN                                        = &H28
%GWL_WNDPROC                                    = -4
%GCL_HCURSOR                                    = -12
%WM_DESTROY                                     = &H2
%WM_SIZE                                        = &H5
%WM_ACTIVATE                                    = &H6
%WM_PAINT                                       = &HF
%WM_QUIT                                        = &H12
%WM_SETFONT                                     = &H30
%WM_KEYDOWN                                     = &H100
%WM_COMMAND                                     = &H111
%WM_CLOSE                                       = &H10
%WM_TIMER                                       = &H113
%WM_MOUSEMOVE                                   = &H200
%WM_LBUTTONDOWN                                 = &H201
%WM_LBUTTONUP                                   = &H202
%WM_RBUTTONDOWN                                 = &H204
%WM_RBUTTONUP                                   = &H205
%WS_OVERLAPPED                                  = &H0
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_SYSMENU                                     = &H00080000
%WS_THICKFRAME                                  = &H00040000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_OVERLAPPEDWINDOW                            = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%WS_EX_WINDOWEDGE                               = &H00000100
%WS_EX_STATICEDGE                               = &H00020000
%WS_EX_APPWINDOW                                = &H00040000
%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2
%PM_REMOVE                                      = &H0001
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%MB_ICONHAND                                    = &H00000010&
%IDC_ARROW                                      = 32512&
%IDC_SIZEALL                                    = 32646&
%IDC_HAND                                       = 32649&
%SS_CENTER                                      = &H00000001
%SS_SUNKEN                                      = &H00001000
%WM_HSCROLL                                     = &H114
%WM_VSCROLL                                     = &H115
%BST_CHECKED                                    = &H01
%BM_GETCHECK                                    = &HF0
%HWND_TOPMOST                                   = &HFFFFFFFF???

%TBS_AUTOTICKS                                  = &H0001
%TBS_VERT                                       = &H0002
%TBS_HORZ                                       = &H0000
%TBS_BOTTOM                                     = &H0000
%TBM_GETPOS                                     = %WM_USER
%TBM_SETPOS                                     = %WM_USER + 5
%TBM_SETRANGE                                   = %WM_USER + 6
%TBM_SETTICFREQ                                 = %WM_USER + 20
%TBM_SETPAGESIZE                                = %WM_USER + 21
%TBM_SETLINESIZE                                = %WM_USER + 23

%GL_LESS                                        = &H0201
%GL_DEPTH_BUFFER_BIT                            = &H00000100
%GL_COLOR_BUFFER_BIT                            = &H00004000
%GL_LINES                                       = &H0001???
%GL_LINE_LOOP                                   = &H0002???
%GL_LINE_STRIP                                  = &H0003???
%GL_QUADS                                       = &H0007
%GL_SRC_ALPHA                                   = &H0302
%GL_ONE_MINUS_SRC_ALPHA                         = &H0303
%GL_SPECULAR                                    = &H1202
%GL_EMISSION                                    = &H1600
%GL_SHININESS                                   = &H1601
%GL_UNSIGNED_BYTE                               = &H1401
%GL_FRONT                                       = &H0404
%GL_LINE_SMOOTH                                 = &H0B20
%GL_LIGHTING                                    = &H0B50
%GL_COLOR_MATERIAL                              = &H0B57
%GL_DEPTH_TEST                                  = &H0B71
%GL_BLEND                                       = &H0BE2
%GL_PERSPECTIVE_CORRECTION_HINT                 = &H0C50
%GL_TEXTURE_2D                                  = &H0DE1
%GL_NICEST                                      = &H1102
%GL_LIGHT0                                      = &H4000
%GL_LIGHT1                                      = &H4001???
%GL_LIGHT2                                      = &H4002???
%GL_LIGHT3                                      = &H4003???
%GL_LIGHT4                                      = &H4004???
%GL_LIGHT5                                      = &H4005???
%GL_LIGHT6                                      = &H4006???
%GL_LIGHT7                                      = &H4007???
%GL_AMBIENT                                     = &H1200
%GL_DIFFUSE                                     = &H1201
%GL_POSITION                                    = &H1203
%GL_COMPILE                                     = &H1300
%GL_AMBIENT_AND_DIFFUSE                         = &H1602
%GL_FRONT_AND_BACK                              = &H0408???
%GL_RGB                                         = &H1907
%GL_SMOOTH                                      = &H1D01
%GL_LINEAR                                      = &H2601
%GL_TEXTURE_MAG_FILTER                          = &H2800
%GL_TEXTURE_MIN_FILTER                          = &H2801
%GLU_SMOOTH                                     = 100000
%GL_RGBA                                        = &H00001908

%GL_CULL_FACE                                   = &H0B44
%GL_CW                                          = &H0900
%GL_CCW                                         = &H0901
%GL_LEQUAL                                      = &H0203
%GL_TEXTURE_GEN_S                               = &H0C60
%GL_TEXTURE_GEN_T                               = &H0C61
%GL_QUAD_STRIP                                  = &H0008
%GL_ONE                                         = 1
%GL_S                                           = &H2000???
%GL_T                                           = &H2001???
%GL_TEXTURE_GEN_MODE                            = &H2500???
%GL_SPHERE_MAP                                  = &H2402???

%GL_NORMALIZE                                   = &H0BA1???
%GL_POINTS                                      = &H0000
%GL_POINT_SPRITE                                = &H08861
%GL_COORD_REPLACE                               = &H08862

TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE SECURITY_ATTRIBUTES
    nLength AS DWORD
    lpSecurityDescriptor AS LONG
    bInheritHandle AS LONG
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    STYLE AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE PAINTSTRUCT
    hDC AS DWORD
    fErase AS LONG
    rcPaint AS RECT
    fRestore AS LONG
    fIncUpdate AS LONG
    rgbReserved(0 TO 31) AS BYTE
END TYPE

DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION SetWindowLong LIB "USER32.DLL" ALIAS "SetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG, BYVAL lNewLong AS LONG) AS LONG
DECLARE FUNCTION CallWindowProc LIB "USER32.DLL" ALIAS "CallWindowProcA" (BYVAL lpPrevWndFunc AS DWORD, BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" (lpRect AS RECT, BYVAL dsStyle AS LONG, BYVAL bMenu AS LONG, BYVAL dwEsStyle AS DWORD) AS LONG
DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION GetForegroundWindow LIB "USER32.DLL" ALIAS "GetForegroundWindow" () AS DWORD
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS DWORD
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION glGenLists LIB "opengl32.dll" ALIAS "glGenLists" (BYVAL range&) AS DWORD
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION gluNewQuadric  LIB "glu32.dll" ALIAS "gluNewQuadric"  () AS LONG
DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" (BYVAL hInstance AS DWORD, lpIconName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION MessageBox LIB "USER32.DLL" ALIAS "MessageBoxA" (BYVAL hWnd AS DWORD, lpText AS ASCIIZ, lpCaption AS ASCIIZ, BYVAL dwType AS DWORD) AS LONG
DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL dwMsgFilterMin AS DWORD, BYVAL dwMsgFilterMax AS DWORD, BYVAL dwRemoveMsg AS DWORD) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" (BYVAL hWnd AS DWORD, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetClassLong LIB "USER32.DLL" ALIAS "SetClassLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG, BYVAL dwNewLong AS DWORD) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION WindowFromPoint LIB "USER32.DLL" ALIAS "WindowFromPoint" (BYVAL xPoint AS LONG, BYVAL yPoint AS LONG) AS LONG
DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD
DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG, BYVAL uElapse AS DWORD, BYVAL lpTimerFunc AS LONG) AS LONG
DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG) AS LONG

DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL MODE AS DWORD)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL ntarget AS DWORD, BYVAL texture AS DWORD)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL sfactor AS DWORD, BYVAL dfactor AS DWORD)
DECLARE SUB glCallList LIB "opengl32.dll" ALIAS "glCallList" (BYVAL list AS DWORD)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL mask AS DWORD)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL alpha AS SINGLE)
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL depth AS DOUBLE)
DECLARE SUB glColor4fv LIB "opengl32.dll" ALIAS "glColor4fv" (v AS ANY)
DECLARE SUB glColorMaterial LIB "opengl32.dll" ALIAS "glColorMaterial" (BYVAL face AS DWORD, BYVAL MODE AS DWORD)
DECLARE SUB glDepthFunc LIB "opengl32.dll" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL cap AS DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL cap AS DWORD)
DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd" ()
DECLARE SUB glEndList LIB "opengl32.dll" ALIAS "glEndList" ()
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL n&, textures AS ANY)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL ntarget AS DWORD, BYVAL MODE AS DWORD)
DECLARE SUB glLightfv LIB "opengl32.dll" ALIAS "glLightfv" (BYVAL light AS DWORD, BYVAL pname AS DWORD, params AS ANY)
DECLARE SUB glLineWidth LIB "opengl32.dll" ALIAS "glLineWidth" (BYVAL nwidth AS SINGLE)
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity" ()
DECLARE SUB glNewList LIB "opengl32.dll" ALIAS "glNewList" (BYVAL list AS DWORD, BYVAL MODE AS DWORD)
DECLARE SUB glRotatef LIB "opengl32.dll" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL MODE AS DWORD)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL s AS SINGLE, BYVAL t AS SINGLE)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL ntarget AS DWORD, BYVAL level&, BYVAL internalformat&, BYVAL nwidth&, BYVAL height&, BYVAL border&, BYVAL format AS DWORD, BYVAL ntype AS DWORD, npixels AS ANY)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL ntarget AS DWORD, BYVAL pname AS DWORD, BYVAL param&)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB gluCylinder    LIB "glu32.dll" ALIAS "gluCylinder"    (BYVAL qobj AS DWORD, BYVAL baseRadius#, BYVAL topRadius#, BYVAL nheight#, BYVAL slices&, BYVAL stacks AS LONG)
DECLARE SUB gluDeleteQuadric    LIB "glu32.dll" ALIAS "gluDeleteQuadric"   (BYVAL STATE AS DWORD)
DECLARE SUB gluDisk   LIB "glu32.dll" ALIAS "gluDisk"   (BYVAL qobj AS DWORD, BYVAL innerRadius#, BYVAL outerRadius#, BYVAL slices&, BYVAL loops AS LONG)
DECLARE SUB gluQuadricNormals   LIB "glu32.dll" ALIAS "gluQuadricNormals"  (BYVAL quadObject AS DWORD, BYVAL normals AS DWORD)
DECLARE SUB gluQuadricTexture   LIB "glu32.dll" ALIAS "gluQuadricTexture"  (BYVAL quadObject AS DWORD, BYVAL textureCoords AS DWORD)' ANY)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL alpha AS SINGLE)
DECLARE SUB InitCommonControls LIB "COMCTL32.DLL" ALIAS "InitCommonControls" ()
DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)
DECLARE SUB glMaterialfv LIB "OPENGL32.DLL" ALIAS "glMaterialfv" (BYVAL face AS DWORD, BYVAL pname AS DWORD, BYREF params AS SINGLE)
DECLARE SUB glColor3f LIB "OPENGL32.DLL" ALIAS "glColor3f" (BYVAL nRed AS SINGLE, BYVAL nGreen AS SINGLE, BYVAL nBlue AS SINGLE)
DECLARE SUB glPopMatrix LIB "OPENGL32.DLL" ALIAS "glPopMatrix" ()
DECLARE SUB glPushMatrix LIB "OPENGL32.DLL" ALIAS "glPushMatrix" ()
DECLARE SUB glColor4ub LIB "OPENGL32.DLL" ALIAS "glColor4ub" (BYVAL nRed AS BYTE, BYVAL nGreen AS BYTE, BYVAL nBlue AS BYTE, BYVAL alpha AS BYTE)
DECLARE SUB glScalef LIB "OPENGL32.DLL" ALIAS "glScalef" ( BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL n&, textures AS ANY)

DECLARE SUB glVertex3fv LIB "OPENGL32.DLL" ALIAS "glVertex3fv" (BYVAL DWORD)
DECLARE SUB glTexEnvi LIB "opengl32.dll" ALIAS "glTexEnvi" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glPointSize LIB "opengl32.dll" ALIAS "glPointSize" (BYVAL lsize AS SINGLE)
DECLARE SUB glLineWidth LIB "opengl32.dll" ALIAS "glLineWidth" (BYVAL nwidth AS SINGLE)

'------------------------------------------------------------------------------------------
#INCLUDE "WINLIFT.INC"
#INCLUDE "GDImage.inc"
#INCLUDE "BassAudio.inc"
#RESOURCE "glicon.pbr"

'------------------------------------------------------------------------------------------
DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

%IDC_GLCTRL    = -100
%IDC_STATIC    = -101
%IDC_LABEL     = -102
%IDC_ZOOM      = -103
%IDC_CLOCK     = -104
%IDC_LOGO      = -105
%IDC_TIMER     = -107

TYPE THISOBJECT
    radius      AS SINGLE
    barsize     AS SINGLE
    xoff        AS SINGLE
    yoff        AS SINGLE
    zoff        AS SINGLE
    xrot        AS SINGLE
    yrot        AS SINGLE
    xcpy        AS SINGLE
    ycpy        AS SINGLE
    move        AS LONG
    xdown       AS LONG
    ydown       AS LONG
    mouseDown   AS LONG
    listIndex   AS LONG
END TYPE

GLOBAL glObj AS THISOBJECT
GLOBAL mt() AS ZGLTEXTUREX
GLOBAL g_hMain, g_hGLcontrol, g_hGLproc AS DWORD
GLOBAL g_UseFont AS ZGLFONT
GLOBAL g_sResource AS STRING
GLOBAL gColor() AS BYTE

TYPE TVertex
    X AS SINGLE
    Y AS SINGLE
    Z AS SINGLE
END TYPE

%TUNNEL_START       = 2800
%TUNNEL_END         = 29500
%MONOLITH_SHOW      = 31500

MACRO TEXTURE_SPEED = 0.022

TYPE TParticle
    X AS SINGLE
    Y AS SINGLE
    Z AS SINGLE
    XSpeed AS SINGLE
    YSpeed AS SINGLE
    ZSpeed AS SINGLE
END TYPE

GLOBAL Particle() AS TParticle
GLOBAL g_SoundExplode AS LONG

FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 16
    LOCAL zMessage    AS ASCIIZ * 260
    LOCAL dwExStyle, dwStyle, hMutex, hFound, hCtrl AS DWORD
    LOCAL rc          AS RECT
    LOCAL x, y        AS LONG
    LOCAL p           AS POINTAPI

    zClass = "ZGLDISPLAY"

    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN ShowWindow(hFound, %SW_RESTORE)
          SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized& = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized&   = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = hInstance
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized& = %TRUE
    END IF
'
    IF IsInitialized& THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       ELSE
          ZI_LoadDLL("")
       END IF
     '************************************************************************************

'
     ' Window Extended Style
       dwExStyle = %WS_EX_APPWINDOW OR %WS_EX_WINDOWEDGE
     ' Windows Style
       dwStyle = %WS_OVERLAPPEDWINDOW
       SetRect(rc, 0, 0, 868, 532)
       AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       zMessage = "StarGate"
       g_hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             zMessage, _             ' Window Title
                             dwStyle OR _            ' Defined Window Style
                             %WS_CLIPSIBLINGS OR _   ' Required Window Style
                             %WS_CLIPCHILDREN, _     ' Required Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             hInstance, _            ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE

       IF g_hMain THEN

        ' *******************************************************************************
        ' Alternate methode to create a GDImage OpenGL control
        ' Note: when GDImage is active the OpenGL $GLImageClassName is already registered
        ' -------------------------------------------------------------------------------
          g_hGLcontrol = CreateWindowEx(0, _
                                 $GLImageClassName, _         ' Make it an OpenGL control
                                 "", _                        ' Currently not used
                                 %WS_CHILD OR %WS_VISIBLE, _  ' window style
                                 10, _                        ' initial x position
                                 10, _                        ' initial y position
                                 712, _                       ' Calculate Window Width
                                 512, _                       ' Calculate Window Height
                                 g_hMain, _                   ' parent window handle
                                 %IDC_GLCTRL, _               ' ControlID
                                 hInstance, _                 ' program instance handle
                                 BYVAL %NULL)                 ' creation parameters

'         // Subclass the OpenGL control
          IF g_hGLcontrol THEN
             g_hGLproc = SetWindowLong(g_hGLcontrol, %GWL_WNDPROC, CODEPTR(glWndProc))
          END IF

          ZI_SetAnchorMode(g_hGLcontrol, %ANCHOR_HEIGHT_WIDTH)  ' Anchor the control (make it a resizable)


'         // Add trackbar
          hCtrl = CreateWindowEx( 0, _
                                 "MSCTLS_TRACKBAR32", _
                                 "", _
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %TBS_HORZ OR %TBS_BOTTOM OR %TBS_AUTOTICKS, _
                                 740, 457, 120, 16, _
                                 g_hMain, %IDC_ZOOM, _
                                 hInstance, _
                                 BYVAL %NULL)
          ZI_SetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
'         // Setup the trackbar parameters.
          SendMessage(hCtrl, %TBM_SETPAGESIZE, 0, 1)
          SendMessage(hCtrl, %TBM_SETLINESIZE, 0, 1)
          SendMessage(hCtrl, %TBM_SETTICFREQ, 0, 1)
          SendMessage(hCtrl, %TBM_SETRANGE, 1, MAK(LONG, 1, 100)) '// Set the zoom range
          SendMessage(hCtrl, %TBM_SETPOS, 1, 55)


          g_sResource = EXE.PATH$ + "Resource\"

        ' ----------------------------------------
        ' Load any of the supported GDImage graphic format to create a texture
          InitOpenGL()

          g_UseFont.fontName = "Pristina"
          g_UseFont.fontHeight = 14
          g_UseFont.fontWeight = %FW_BOLD
          ZI_BuildGLfont(ZI_GetGLDC(g_hGLcontrol), g_UseFont) ' Build OpenGL font for our OpenGL window

          IF skInitEngine("Podcast.sks", "") THEN

             skSkinWindow(g_hMain, "Dock|Undock|Minimize|Maximize|Restore|Close")

'            // Add a skinned border around the GDImage control.
             GetWindowRect(g_hGLcontrol, rc)
             p.x = rc.nLeft: p.y = rc.nTop
             ScreenToClient(g_hMain, p)
             skBorder(g_hGLcontrol, p.x - 1, p.y - 1, rc.nRight - rc.nLeft + 2, rc.nBottom - rc.nTop + 2, 0, 1)

'            // Add a WinLIFT clock
             hCtrl = skClockCtrl(g_hMain, g_sResource + "Clock.png", p.x + rc.nRight - rc.nLeft + 31, p.y, 0, 0, %IDC_CLOCK, &H7FCB0000, &H7F8F8F8F, 0)
             skSetAnchorCtrl(hCtrl, %ANCHOR_RIGHT)
             skCreateToolTip(hCtrl, "WinLIFT clock widget")


'            // Add a static control to display the help text.
             GetClientRect(g_hMain, rc)
             zMessage = "Mouse buttons" + $CRLF + $CRLF + "Left: rotation, and view angle." + $CRLF + _
                        $CRLF + "Right: new X,Y location."
             hCtrl = CreateWindowEx(0, "STATIC", zMessage, %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER OR %WS_BORDER, _
                                    rc.nRight - (129 + 5), 10 + (22 + 5) * 10 + 5, 129, 135, g_hMain, %IDC_LABEL, hInstance, BYVAL %NULL)
'            // Skin the static control on the fly.
             skSkinChildCtrl(hCtrl, 0)
             ZI_SetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
'            // Use a custom font with the static control.
             skSetLabelFont(hCtrl, "TREBUCHET MS", 15, skARGB(200, 255,255,255), %FontStyleBold)


'            // Diplay the GDImage logo.
             'hCtrl = skStaticImage(g_hMain, g_sResource + "GDImage.png", rc.nRight - (129 + 6), 350, 124, 45, %IDC_LOGO)
             'ZI_SetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)

             ta.AudioFile = g_sResource$ + "intro.ogg"
             BassChannelPlay(g_hMain)

'            // All is done, it is time to show the main window.
             ShowWindow(g_hMain, iCmdShow)
             SetForegroundWindow(g_hMain)                ' Slightly Higher Priority
             SetFocus(g_hMain)                           ' Sets Keyboard Focus To The Window

'            // Main message pump.
             SetTimer(g_hMain, %IDC_TIMER, 0, 0) ' 60 FPS
             WHILE GetMessage(Msg, 0, 0, 0)
                TranslateMessage(Msg)
                DispatchMessage(Msg)
             WEND
             KillTimer(g_hMain, %IDC_TIMER)

             BassCloseChannel()
             BassFree()

          END IF

          FUNCTION = msg.wParam
       END IF

    END IF

    IF hMutex THEN CloseHandle(hMutex)
'
END FUNCTION

SUB InitObject()

    glObj.xoff = -0.0  ' Initial x location.
    glObj.yoff = -0.0  ' Initial y location.
    glObj.zoff = -3.0  ' Initial zoom factor.

    glObj.xrot = 5.0
    glObj.yrot = 0.0
    glObj.radius = 0.0

'   // User variables
    DIM Particle(1 TO 50) AS TParticle

END SUB

' Set up our OpenGL scene
SUB InitOpenGL()
    InitObject()

    LOCAL I, J AS LONG

    glClearColor(0.0, 0.0, 0.0, 0.0) 	   '// Black Background
'   glShadeModel(%GL_SMOOTH)             '// Enables Smooth Color Shading
    glClearDepth(1.0)                    '// Depth Buffer Setup
    glEnable(%GL_DEPTH_TEST)             '// Enable Depth Buffer
    glDepthFunc(%GL_LESS)		             '// The Type Of Depth Test TO Do
    glBlendFunc(%GL_SRC_ALPHA, %GL_ONE)
    glHint(%GL_PERSPECTIVE_CORRECTION_HINT, %GL_NICEST) '//Realy Nice perspective calculations


    DIM LightDiffuse(3) AS SINGLE:  ARRAY ASSIGN LightDiffuse()  = 0.5, 0.5, 1.0, 1.0
    DIM LightAmbient(3) AS SINGLE:  ARRAY ASSIGN LightAmbient()  = 0.3, 0.3, 0.3, 1.0
    DIM LightPosition(3) AS SINGLE: ARRAY ASSIGN LightPosition() = -2.0, 2.0, -15.0, 1.0

    glLightfv(%GL_LIGHT0, %GL_DIFFUSE, LightDiffuse(0))     ' Setup the Diffuse Light
    glLightfv(%GL_LIGHT0, %GL_AMBIENT, LightDiffuse(0))     ' Setup the Ambient Light
    glLightfv(%GL_LIGHT0, %GL_POSITION,  LightPosition(0))  ' Position the Light

    glMaterialfv(%GL_FRONT, %GL_SPECULAR, LightDiffuse(0))
    glMaterialfv(%GL_FRONT, %GL_EMISSION, 0.05)
    glMaterialfv(%GL_FRONT, %GL_SHININESS, 5.0)

    glColorMaterial(%GL_FRONT, %GL_AMBIENT_AND_DIFFUSE)


    glEnable(%GL_TEXTURE_2D)             '// Enable Texture Mapping

'   //Load textures
    DIM mt(8) AS ZGLTEXTUREX
    mt(0).FullName = g_sResource + "tunnel.png":     mt(0).ID = 1: mt(0).Square = 0 ' Tunnel
    mt(1).FullName = g_sResource + "background.png": mt(1).ID = 2: mt(1).Square = 0 ' Bacgkround
    mt(2).FullName = g_sResource + "particle.png":   mt(2).ID = 3: mt(2).Square = 0 ' Particle
    mt(3).FullName = g_sResource + "starburst.jpg":  mt(3).ID = 4: mt(3).Square = 0 ' StarBurst
    mt(4).FullName = g_sResource + "monolith.png":   mt(4).ID = 5: mt(4).Square = 0 ' Monolith
    mt(5).FullName = g_sResource + "monolith0.png":  mt(5).ID = 6: mt(5).Square = 0 ' Monolith0
    mt(6).FullName = g_sResource + "stargate.jpg":   mt(6).ID = 7: mt(6).Square = 0 ' Stargate
    mt(7).FullName = g_sResource + "hub.png":        mt(7).ID = 8: mt(7).Square = 1 ' Hub
    mt(8).FullName = g_sResource + "Side.png":       mt(8).ID = 9: mt(8).Square = 0 ' Hub

    ZI_MakeMultipleTexture(BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

    ColorInit()

    Randomize(TIMER)

'   // Initialise all particles
    FOR I = 1 TO UBOUND(Particle())
        Particle(I).XSpeed = (RND(0,99) / 2000 - 0.025) '// Random speed
        Particle(I).YSpeed = (RND(0,99) / 2000 - 0.025)
        Particle(I).ZSpeed = (RND(0,99) / 3000 + 0.2)
        Particle(I).X = RND(0,99) / 1000                '// Give it a random position based on the speed.
        Particle(I).Y = RND(0,99) / 1000
        Particle(I).Z = RND(0,99) / 1000
    NEXT

'   // shuffle particles around a bit
    FOR J = 1 TO 500
        FOR I = 1 TO UBOUND(Particle())
            Particle(I).X += Particle(I).XSpeed
            Particle(I).Y += Particle(I).YSpeed
            Particle(I).Z += Particle(I).ZSpeed
            IF SQR(Particle(I).X * Particle(I).X + Particle(I).Y * Particle(I).Y + Particle(I).Z * Particle(I).Z) > 16 THEN
               Particle(I).X = 0
               Particle(I).Y = 0
               Particle(I).Z = 0
            END IF
        NEXT
    NEXT

END SUB

SUB SetZoom(BYVAL zoom AS LONG)
    ZI_SetGLzoom(g_hGLcontrol, zoom)
    ZI_ResizeGLWindow(g_hGLcontrol)
END SUB

SUB ColorInit()
    DIM gColor(1 TO 33, 1 TO 3) AS BYTE
    gColor( 1, 1) =  32: gColor( 1, 2) =  32: gColor( 1, 3) =  32
    gColor( 2, 1) =   0: gColor( 2, 2) =  44: gColor( 2, 3) = 233
    gColor( 3, 1) =   0: gColor( 3, 2) =  67: gColor( 3, 3) = 210
    gColor( 4, 1) =   0: gColor( 4, 2) =  89: gColor( 4, 3) = 187
    gColor( 5, 1) =   0: gColor( 5, 2) = 112: gColor( 5, 3) = 164
    gColor( 6, 1) =   0: gColor( 6, 2) = 135: gColor( 6, 3) = 142
    gColor( 7, 1) =   0: gColor( 7, 2) = 159: gColor( 7, 3) = 117
    gColor( 8, 1) =   0: gColor( 8, 2) = 183: gColor( 8, 3) =  88
    gColor( 9, 1) =   0: gColor( 9, 2) = 207: gColor( 9, 3) =  58
    gColor(10, 1) =   0: gColor(10, 2) = 231: gColor(10, 3) =  29
    gColor(11, 1) =  26: gColor(11, 2) = 234: gColor(11, 3) =  26
    gColor(12, 1) =  52: gColor(12, 2) = 237: gColor(12, 3) =  23
    gColor(13, 1) =  79: gColor(13, 2) = 240: gColor(13, 3) =  20
    gColor(14, 1) = 105: gColor(14, 2) = 243: gColor(14, 3) =  17
    gColor(15, 1) = 126: gColor(15, 2) = 245: gColor(15, 3) =  14
    gColor(16, 1) = 147: gColor(16, 2) = 248: gColor(16, 3) =  11
    gColor(17, 1) = 168: gColor(17, 2) = 250: gColor(17, 3) =   8
    gColor(18, 1) = 189: gColor(18, 2) = 253: gColor(18, 3) =   5
    gColor(19, 1) = 210: gColor(19, 2) = 255: gColor(19, 3) =   2
    gColor(20, 1) = 233: gColor(20, 2) = 255: gColor(20, 3) =   0
    gColor(21, 1) = 255: gColor(21, 2) = 255: gColor(21, 3) =   0
    gColor(22, 1) = 255: gColor(22, 2) = 251: gColor(22, 3) =   0
    gColor(23, 1) = 255: gColor(23, 2) = 235: gColor(23, 3) =   0
    gColor(24, 1) = 255: gColor(24, 2) = 215: gColor(24, 3) =   0
    gColor(25, 1) = 255: gColor(25, 2) = 196: gColor(25, 3) =   0
    gColor(26, 1) = 255: gColor(26, 2) = 176: gColor(26, 3) =   0
    gColor(27, 1) = 255: gColor(27, 2) = 156: gColor(27, 3) =   0
    gColor(28, 1) = 253: gColor(28, 2) = 137: gColor(28, 3) =   0
    gColor(29, 1) = 255: gColor(29, 2) = 117: gColor(29, 3) =   0
    gColor(30, 1) = 255: gColor(30, 2) =  97: gColor(30, 3) =   0
    gColor(31, 1) = 255: gColor(31, 2) =  78: gColor(31, 3) =   0
    gColor(32, 1) = 255: gColor(32, 2) =  58: gColor(32, 3) =   0
    gColor(33, 1) = 255: gColor(33, 2) =   0: gColor(33, 3) =   0
END SUB

SUB SetLevelColr(BYVAL nLevel AS LONG)
    LOCAL cbR, cbG, cbB AS BYTE

    nLevel += 1: IF nLevel > 33 THEN nLevel = 33
    IF nLevel > 0 THEN
       cbR = gColor(nLevel, 1)
       cbG = gColor(nLevel, 2)
       cbB = gColor(nLevel, 3)
    END IF
    glColor4ub(cbR , cbG , cbB, 64)

END SUB

SUB DrawMonolith (nValue AS LONG, BYVAL Pulse AS SINGLE, BYVAL MonolithAngle AS SINGLE, BYVAL nItem AS LONG)

    LOCAL x, y , z, n AS SINGLE

    x = 0.24: y = 0.74: z = 0.074

    Pulse = ABS(Pulse / 32)

    glEnable(%GL_CULL_FACE)

    glColor3f(1, 1, 1)

    glDisable(%GL_BLEND)
    glEnable(%GL_LIGHT0)                                      ' Enable Light0
    glEnable(%GL_LIGHTING)                                    ' Enable Lighting
    glEnable(%GL_COLOR_MATERIAL)                              ' Enable Coloring Of Material

'   // BackFace
    glBindTexture(%GL_TEXTURE_2D, mt(4).Texture)
    glBegin(%GL_QUADS)
       glTexCoord2f(1.0, 0.0): glVertex3f(-x,-y,-z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f(-x, y,-z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f( x, y,-z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f( x,-y,-z) ' Bottom Left Of The Texture And Quad
    glEnd()
	 IF nItem = 1 THEN
       glColor3f(0.25, 1, 1)
    ELSEIF nItem = 2 THEN
       glColor3f(1, 1, 1)
    ELSE
       glColor3f(1, 1, 0.25)
    END IF
'   // TopFace
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 1.0): glVertex3f(-x, y,-z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f(-x, y, z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f( x, y, z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f( x, y,-z) ' Top Right Of The Texture And Quad
    glEnd()
'   // BottomFace
    glBegin(%GL_QUADS)
       glTexCoord2f(1.0, 1.0): glVertex3f(-x,-y,-z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f( x,-y,-z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f( x,-y, z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f(-x,-y, z) ' Bottom Right Of The Texture And Quad
    glEnd()
    glColor3f(1, 1, 1)
	 glBindTexture(%GL_TEXTURE_2D, mt(8).Texture)
'   // RightFace
    glBegin(%GL_QUADS)
       glTexCoord2f(1.0, 0.0): glVertex3f( x,-y,-z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f( x, y,-z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f( x, y, z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f( x,-y, z) ' Bottom Left Of The Texture And Quad
    glEnd()
'   // LeftFace
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 0.0): glVertex3f(-x,-y,-z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f(-x,-y, z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f(-x, y, z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f(-x, y,-z) ' Top Left Of The Texture And Quad
    glEnd()
	 glBindTexture(%GL_TEXTURE_2D, mt(4).Texture)
'   // FrontFace
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 0.0): glVertex3f(-x,-y, z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f( x,-y, z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f( x, y, z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f(-x, y, z) ' Top Left Of The Texture And Quad
    glEnd()



    glEnable(%GL_BLEND)


'   // Display HAL
    IF nItem = 1 THEN
       glColor3f(0.25, 1, 1)
    ELSEIF nItem = 2 THEN
       glColor3f(1, 1, 1)
    ELSE
       glColor3f(1, 1, 0.25)
    END IF
    glBindTexture(%GL_TEXTURE_2D, mt(7).Texture)
    x = 0.12: y = 0.12: z = 0.0741
    glPushMatrix()
       glTranslatef(0.0, -0.55, 0)
       glRotatef(MonolithAngle, 0, 0, 1)
       glBegin(%GL_QUADS)
          glTexCoord2f(0.0, 0.0): glVertex3f(-x,-y, z) ' Bottom Left Of The Texture And Quad
          glTexCoord2f(1.0, 0.0): glVertex3f( x,-y, z) ' Bottom Right Of The Texture And Quad
          glTexCoord2f(1.0, 1.0): glVertex3f( x, y, z) ' Top Right Of The Texture And Quad
          glTexCoord2f(0.0, 1.0): glVertex3f(-x, y, z) ' Top Left Of The Texture And Quad
       glEnd()
    glPopMatrix()
    x = 0.24: y = 0.74: z = 0.074
'   // End HAL


'   // Get audio data and set the color accordingly.
    IF ta.Channel THEN
       SetLevelColr(nValue)
    END IF
    n = 0.02
    x += n + Pulse: y += n + Pulse: z += n + Pulse
    glBindTexture(%GL_TEXTURE_2D, mt(5).Texture)

'   // BackFace
    glBegin(%GL_QUADS)
       glTexCoord2f(1.0, 0.0): glVertex3f(-x,-y,-z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f(-x, y,-z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f( x, y,-z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f( x,-y,-z) ' Bottom Left Of The Texture And Quad
    glEnd()
'   // TopFace
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 1.0): glVertex3f(-x, y,-z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f(-x, y, z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f( x, y, z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f( x, y,-z) ' Top Right Of The Texture And Quad
    glEnd()
'   // BottomFace
    glBegin(%GL_QUADS)
       glTexCoord2f(1.0, 1.0): glVertex3f(-x,-y,-z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f( x,-y,-z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f( x,-y, z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f(-x,-y, z) ' Bottom Right Of The Texture And Quad
    glEnd()
'   // RightFace
    glBegin(%GL_QUADS)
       glTexCoord2f(1.0, 0.0): glVertex3f( x,-y,-z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f( x, y,-z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f( x, y, z) ' Top Left Of The Texture And Quad
       glTexCoord2f(0.0, 0.0): glVertex3f( x,-y, z) ' Bottom Left Of The Texture And Quad
    glEnd()
'   // LeftFace
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 0.0): glVertex3f(-x,-y,-z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f(-x,-y, z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f(-x, y, z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f(-x, y,-z) ' Top Left Of The Texture And Quad
    glEnd()
'   // FrontFace
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 0.0): glVertex3f(-x,-y, z) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f( x,-y, z) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f( x, y, z) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f(-x, y, z) ' Top Left Of The Texture And Quad
    glEnd()

    glDisable(%GL_LIGHT0)                                    ' Enable Light ONE
    glDisable(%GL_LIGHTING)                                  ' Enable Lighting
    glDisable(%GL_COLOR_MATERIAL)                            ' Enable Coloring Of Material

    glDisable(%GL_CULL_FACE)

END SUB

SUB RenderOpenGL()
    LOCAL I, J, DemoTime, ShowMonolith, ZoomIs, BackgroundIsFix, nLevel AS LONG
    LOCAL Angle, C, R, A1, A2, A3, A4 AS SINGLE
    LOCAL ParticleX, ParticleY, ParticleZ AS SINGLE
    LOCAL LastTime AS DWORD

    STATIC LastC, MonolithAngle AS SINGLE
    STATIC DemoStart, ElapsedTime AS DWORD
    STATIC TimeZoomOut AS DWORD

    DIM Tunnels(0 TO 13, 0 TO 32) AS TVertex

    LOCAL nValue, nLValue, nRValue AS LONG, cPulse, Pulse AS SINGLE
    IF ta.Channel THEN

       nValue          = BASS_ChannelGetLevel(ta.Channel)
       ta.Lpeak        = SolvePeak(LO(WORD, nValue), 128)
       ta.Rpeak        = SolvePeak(HI(WORD, nValue), 128)
       ta.FFTdata      = BassChannelGetData()
       ta.FFTsize      = 256
       ta.WIMdata      = BassChannelGetWimData(ta.Channel)

       nLValue = (ta.Lpeak / 700)
       nRValue = (ta.Rpeak / 768)
       nValue = MAX&(nLValue, nRValue)
       Pulse = nValue / 14

    END IF


    glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)   '// Clear The Screen And The Depth Buffer
    glLoadIdentity()                                        '// Reset The View

    IF DemoStart = 0 THEN DemoStart = GetTickCount()
    LastTime = ElapsedTime
    ElapsedTime = GetTickCount() - DemoStart     '// Calculate Elapsed Time
    ElapsedTime = (LastTime + ElapsedTime) \ 2   '// Average it out FOR smoother movement

    DemoTime = (ElapsedTime - %TUNNEL_START)

    IF (%MONOLITH_SHOW - ElapsedTime) < 0 THEN
       ShowMonolith = -1
       IF ta.Channel = 0 THEN
          ta.AudioFile = g_sResource$ + "monolith.ogg"
          BassChannelPlay(g_hMain)
       END IF
    END IF

'   // Save current zoom, then switch to a fixed zoom for the background.
    ZoomIs = ZI_GetGLzoom(g_hGLcontrol)
    SetZoom(45)

    glDisable(%GL_DEPTH_TEST)
    glEnable(%GL_BLEND)
'   // Draw background
    IF ShowMonolith = 0 THEN
       cPulse = DemoTime / 400
       glColor3f(1 - cpulse / 36, 1 - cpulse / 45, 1 - cPulse / 48)
    ELSE
       cPulse = Pulse / 4
       glColor3f(1 - cPulse, 1 - cPulse, 1)
    END IF
    glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 0.0): glVertex3f(-80,-40,-80.0 + cPulse) ' Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0, 0.0): glVertex3f( 80,-40,-80.0 + cPulse) ' Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0, 1.0): glVertex3f( 80, 40,-80.0 + cPulse) ' Top Right Of The Texture And Quad
       glTexCoord2f(0.0, 1.0): glVertex3f(-80, 40,-80.0 + cPulse) ' Top Left Of The Texture And Quad
    glEnd()

    IF ShowMonolith THEN
'      // Rotate the flare hover the background.
       glPushMatrix()
          SetLevelColr(nValue)
          glRotatef(MonolithAngle, 0, 0, 1)
          glBindTexture(%GL_TEXTURE_2D, mt(6).Texture) ' Flare0.png
          glBegin(%GL_QUADS)
             glTexCoord2f(0, 0): glVertex3f(-65,-65, -65)
             glTexCoord2f(1, 0): glVertex3f( 65,-65, -65)
             glTexCoord2f(1, 1): glVertex3f( 65, 65, -65)
             glTexCoord2f(0, 1): glVertex3f(-65, 65, -65)
          glEnd()
       glPopMatrix()
    END IF

'   // Restore the previously saved zoom.
    SetZoom(ZoomIs)

'   // Set the camera location based on user mousing.
    glTranslatef(glObj.xoff, glObj.yoff, glObj.zoff)
    glRotatef(glObj.xrot, 1.0, 0.0, 0.0)
    glRotatef(glObj.yrot, 0.0, 1.0, 0.0)

'   // Startgate entrance
    IF DemoTime < 2000 THEN
       C = DemoTime / 50
       glTranslatef(0, 0, 10 + c)
       glRotatef(DemoTime / 14, 0, 0, 1)
       glBindTexture(%GL_TEXTURE_2D, mt(6).Texture)
       glBegin(%GL_QUADS)
          glTexCoord2f(0.0, 0.0): glVertex3f(-1.0,-1.0, -10.0) ' Bottom Left Of The Texture And Quad
          glTexCoord2f(1.0, 0.0): glVertex3f( 1.0,-1.0, -10.0) ' Bottom Right Of The Texture And Quad
          glTexCoord2f(1.0, 1.0): glVertex3f( 1.0, 1.0, -10.0) ' Top Right Of The Texture And Quad
          glTexCoord2f(0.0, 1.0): glVertex3f(-1.0, 1.0, -10.0) ' Top Left Of The Texture And Quad
       glEnd()
       glTranslatef(0, 0, -(10 + c))
    END IF


    IF ShowMonolith = 0 THEN
       Angle = DemoTime / 14

'      // Setup tunnel coordinates
       A1 = -2 * cos(Angle / 29) - sin(Angle / 13)
       A2 = -2 * sin(Angle / 33) - cos(Angle / 17)
       FOR I = 0 TO 13
          A3 = 0.5235987756 * I
          FOR J = 0 TO 31
             A4 = Angle + 2 * j
             Tunnels(I, J).X = (4.2 - J / 12) * sin(A3) + 2 * cos(A4 / 29) + sin(A4 / 13) + A1
             Tunnels(I, J).Y = (4.2 - J / 12) * cos(A3) + 2 * sin(A4 / 33) + cos(A4 / 17) + A2
          NEXT
       NEXT

'      // Draw the tunnel
       glEnable(%GL_DEPTH_TEST) '// Hide the tunnel in the distance
       glBindTexture(%GL_TEXTURE_2D, mt(0).Texture) ' TunnelTex
       FOR J = 0 TO 31
          A1 = J / 32 + Angle * TEXTURE_SPEED '// Precalculate texture v coords FOR speed
          A2 = (J + 1) / 32 + Angle * TEXTURE_SPEED

'         // Near the end of the tunnel, fade the effect away
          IF J > 24 THEN
             C = 1.0 - (J - 24) / 10
          ELSE
             C = 1.0
          END IF

'         // Fade in tunnel
          IF DemoTime < 2000 THEN C = C * DemoTime / 2000

          glColor3f(C, C, C)

          glBegin(%GL_QUADS)
            FOR I = 0 TO 11
               glTexCoord2f(      I / 12, A1): glVertex3f(Tunnels(I,     J    ).X, Tunnels(I    , J    ).Y, -J  )
               glTexCoord2f((I + 1) / 12, A1): glVertex3f(Tunnels(I + 1, J    ).X, Tunnels(I + 1, J    ).Y, -J  )
               glTexCoord2f((I + 1) / 12, A2): glVertex3f(Tunnels(I + 1, J + 1).X, Tunnels(I + 1, J + 1).Y, -J - 1)
               glTexCoord2f(      I / 12, A2): glVertex3f(Tunnels(I,     J + 1).X, Tunnels(I    , J + 1).Y, -J - 1)
            NEXT
          glEnd()
       NEXT

'      // At the end of the sequence, fade in the starburst
       IF (%TUNNEL_END - ElapsedTime) < 500 THEN

          IF g_SoundExplode = 0 THEN
             g_SoundExplode = -1
             ta.AudioFile = g_sResource$ + "explode.ogg"
             BassChannelPlay(g_hMain)

'            // Setup the ZoomOut duration to show the monolith first time.
             TimeZoomOut = GetTickCount() + ZI_GetGLzoom(g_hGLcontrol) * 100

'            // Update the GDImage mt(1).texture, to replace the initial background with the earth.
             mt(1).FullName = g_sResource + "earth.png"
             ZI_UpdateNamedGLTextureFromFileEx(mt(1).FullName, mt(1).Texture, mt(1).Square)
'            // Update the GDImage mt(6).texture, to replace stargate by the flare.
             mt(6).FullName = g_sResource + "flare0.png"
             ZI_UpdateNamedGLTextureFromFileEx(mt(6).FullName, mt(6).Texture, mt(6).Square)

          END IF

          C = 1 - (%TUNNEL_END - ElapsedTime) / 500
          glColor3f(C, C, C)
          glRotatef(Angle / 2, 0, 0, 1)
          glBindTexture(%GL_TEXTURE_2D, mt(3).Texture) ' StarBurstTex
          glBegin(%GL_QUADS)
             glTexCoord2f(0, 0): glVertex3f(-4.5,-4.5, 0)
             glTexCoord2f(1, 0): glVertex3f( 4.5,-4.5, 0)
             glTexCoord2f(1, 1): glVertex3f( 4.5, 4.5, 0)
             glTexCoord2f(0, 1): glVertex3f(-4.5, 4.5, 0)
          glEnd()
          glRotatef(-Angle, 0, 0, 1)
          glBegin(%GL_QUADS)
             glTexCoord2f(0, 0): glVertex3f(-4.5,-4.5, 0)
             glTexCoord2f(1, 0): glVertex3f( 4.5,-4.5, 0)
             glTexCoord2f(1, 1): glVertex3f( 4.5, 4.5, 0)
             glTexCoord2f(0, 1): glVertex3f(-4.5, 4.5, 0)
          glEnd()
       END IF

'      // Draw the particles
       IF DemoTime > 5000 THEN

          glBindTexture(%GL_TEXTURE_2D, mt(2).Texture) ' ParticleTex
          A1 = -2 * cos(Angle / 29) - sin(Angle / 13)
          A2 = -2 * sin(Angle / 33) - cos(Angle / 17)

          IF (DemoTime > 11000) AND (DemoTime < 23000) THEN
            J = UBOUND(Particle())
          ELSE
            J = 1
          END IF

          glColor3f(1.0, 0.8, 0)
          FOR I = 1 TO J
'             // Set up particle coordinates based on tunnel coords
              ParticleZ = (DemoTime - 7000 - J * 150) / (200 - (DemoTime - 4000) / 140) - Particle(I).Z * 3

              IF ParticleZ > 24 THEN
                 Particle(I).Z = (DemoTime - 7000 - J * 150) / (200 - (DemoTime - 4000) / 140 - 24) / 3
              END IF

              A4 = Angle + 2 * ParticleZ
              ParticleX =  2 * cos(A4 / 29) + sin(A4 / 13) + A1
              ParticleY =  2 * sin(A4 / 33) + cos(A4 / 17) + A2
              R = 1 / (6 + ParticleZ / 2)

              glPushMatrix()
                 glTranslatef(ParticleX + Particle(I).X, ParticleY + Particle(I).Y, -ParticleZ)
                 glScalef(R, R, R)
                 glBegin(%GL_QUADS)
                    glTexCoord2f(0.0, 0.0): glVertex3f(-1, -1, 0)
                    glTexCoord2f(1.0, 0.0): glVertex3f( 1, -1, 0)
                    glTexCoord2f(1.0, 1.0): glVertex3f( 1,  1, 0)
                    glTexCoord2f(0.0, 1.0): glVertex3f(-1,  1, 0)
                 glEnd()
              glPopMatrix()
          NEXT
       END IF
    END IF

    IF ShowMonolith THEN

'      // Shall we ZoomOut to show the monolith the first time.
       LastTime = GetTickCount()
       IF TimeZoomOut > LastTime THEN
          ZoomIs = ZI_GetGLzoom(g_hGLcontrol)
          SetZoom(((ZoomIs * 100) - (TimeZoomOut - LastTime)) / 100)
       END IF

       glPushMatrix()
          glTranslatef(-1.8, -0.20, -1.80)
          glRotatef(MonolithAngle, 0.25, 1, 1)
          DrawMonolith(nValue, Pulse, MonolithAngle, 1)
       glPopMatrix()

       glPushMatrix()
          glTranslatef(1.8, -0.20, -1.80)
          glRotatef(MonolithAngle, 1, 1, .25)
          DrawMonolith(nValue, Pulse, MonolithAngle + 90, 2)
       glPopMatrix()

       glPushMatrix()
          glRotatef(MonolithAngle, 1, 0.25, 1)
          DrawMonolith(nValue, Pulse, MonolithAngle + 180, 3)
       glPopMatrix()

       MonolithAngle += 0.1 + Pulse: MonolithAngle = MonolithAngle MOD 360

       IF TimeZoomOut > LastTime THEN
          SetZoom(ZoomIs)
       END IF

    END IF

'   // Update the display
    ZI_UpdateGLWindow(g_hGLcontrol)

END SUB

SUB PaintMain(BYVAL hWin AS LONG)
    LOCAL ps AS PAINTSTRUCT
    BeginPaint(hWin, ps)
    EndPaint(hWin, ps)

    RenderOpenGL()

END SUB

FUNCTION WndProc(BYVAL hWin AS DWORD, BYVAL Msg AS LONG, BYVAL wParam AS DWORD, BYVAL lParam AS DWORD) AS LONG

    SELECT CASE LONG Msg

    CASE %WM_SIZE
         ZI_ResizeGLWindow(g_hGLcontrol)
         RenderOpenGL()

    CASE %WM_CLOSE
         BassCloseChannel()

    CASE %WM_HSCROLL
         IF GetDlgCtrlId(lParam) = %IDC_ZOOM THEN
            '// Do not use nPosition, because it could be NULL.
            SetZoom(101 - SendMessage(lParam, %TBM_GetPos, 0, 0))
            RenderOpenGL()
         END IF

    CASE %WM_TIMER
         RenderOpenGL()
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_PAINT
         PaintMain(hWin)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
         ZI_DeleteGLFont(g_UseFont)
         ZI_DestroyTexture(BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)
         PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWin, Msg, wParam, lParam)

END FUNCTION

FUNCTION glWndProc(BYVAL hWnd AS DWORD, BYVAL Msg AS LONG, BYVAL wParam AS DWORD, BYVAL lParam AS DWORD) AS LONG

    LOCAL rc AS RECT
    STATIC LeftMousing, RightMousing, wasLX, wasLY, wasRX, wasRY AS LONG

    LOCAL x, y, dx, dy AS LONG

    SELECT CASE LONG Msg

    CASE %WM_PAINT
        RenderOpenGL()

    CASE %WM_LBUTTONDOWN
        IF (LeftMousing = %FALSE) THEN
            x = LO(INTEGER, lParam): y = HI(INTEGER, lParam)
            glObj.xcpy = glObj.xrot
            glObj.ycpy = glObj.yrot

            glObj.xdown = x
            glObj.ydown = y
            LeftMousing = %TRUE
        END IF
        IF (GetFocus() <> hWnd) THEN SetFocus(hWnd)

    CASE %WM_LBUTTONUP
        LeftMousing = %FALSE

    CASE %WM_RBUTTONDOWN
        IF (RightMousing = %FALSE) THEN
            x = LO(INTEGER, lParam): y = HI(INTEGER, lParam)
            glObj.xcpy = glObj.xoff
            glObj.ycpy = glObj.yoff

            glObj.xdown = x
            glObj.ydown = y
            RightMousing = %TRUE
        END IF
        IF (GetFocus() <> hWnd) THEN SetFocus(hWnd)

    CASE %WM_RBUTTONUP
        RightMousing = %FALSE

    CASE %WM_MOUSEMOVE
        x = LO(INTEGER, lParam): y = HI(INTEGER, lParam)

        IF (NOT ZI_IsLButtonDown()) THEN
            LeftMousing = %FALSE
        ELSE
            IF ((wasLX <> x) OR (wasLY <> y)) THEN
                IF (LeftMousing) THEN
                   dx = x - glObj.xdown: glObj.yrot = glObj.ycpy + dx / 2.0
                   dy = y - glObj.ydown: glObj.xrot = glObj.xcpy + dy / 2.0
                END IF
                RenderOpenGL()
            END IF
            wasLX = x: wasLY = y
        END IF

        IF (NOT ZI_IsRButtonDown()) THEN
            RightMousing = %FALSE
        ELSE
            IF ((wasLX <> x) OR (wasLY <> y)) THEN
                IF (RightMousing) THEN
                    GetClientRect(g_hGLcontrol, rc)
                    dx = x - glObj.xdown: glObj.xoff = glObj.xcpy - (-45 * dx) / (12.0 * rc.nRight)  ' Use 12.0 instead of 2.0 to reduce sensitivity
                    dy = y - glObj.ydown: glObj.yoff = glObj.ycpy + (-45 * dy) / (12.0 * rc.nBottom) ' Use 12.0 instead of 2.0 to reduce sensitivity
                END IF
                RenderOpenGL()
            END IF
            wasRX = x: wasRY = y
        END IF

    END SELECT

    FUNCTION = CallWindowProc(g_hGLproc, hWnd, Msg, wParam, lParam)

END FUNCTION
